﻿var IsPlaySound;
var CurrentId;

function Load()
{
  document.getElementById("errorInfo").innerHTML = "";
  IsPlaySound = System.Gadget.Settings.readString("playsnd")  == "True";  
  document.getElementById("typex").value = System.Gadget.Settings.readString("typex");
  document.getElementById("session").value = System.Gadget.Settings.readString("CurrentSession");
  switch (document.getElementById("typex").value)
  {
    case "transfer":
    {
      document.getElementById("windowCaption").innerHTML = "Информация о переводе";
      ShowWaitingContent("Идет загрузка информации по переводу...");
      GetTransfersByPage();
      break;
    }
    case "invoice":
    {
      document.getElementById("windowCaption").innerHTML = "Информация о счете";
      ShowWaitingContent("Идет загрузка информации по счету...");
      GetInvoicesByPage();
      break;
    }
    case "message":
    {
      document.getElementById("windowCaption").innerHTML = "Информация о сообщение";
      break;
    } 
  }
}

function ShowWaitingContent(message)
{
  document.getElementById("errorInfo").innerHTML = "";
  document.getElementById("contentInfo").innerHTML = "";
  var img = document.createElement("IMG");
  img.src = "../../images/loading24.gif";
  document.getElementById("contentInfo").appendChild(img);
  document.getElementById("contentInfo").innerHTML += "<span class='font' style='padding-left: 8px'>"+message+"</span>"; 
  document.getElementById("accept").disabled = true;
  document.getElementById("reject").disabled = true;
}

//Счета
function GetInvoicesByPage()
{
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+document.getElementById("session").value+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.PageNumber = 1;
  callObj.params.ItemsPerPage = 1;
  callObj.params.StateFilter = "Created";
  callObj.params.ToUserId = System.Gadget.Settings.readString("CurrentUserId");
  callObj.funcName = "GetInvoicesByPage";
  var iCallID = service.Processing.callService(_GetInvoicesByPage, callObj);
}

function _GetInvoicesByPage(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("errorInfo").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
    }
    else
    {
      document.getElementById("errorInfo").innerText = xfaultstring;
    }
  }
  else
  {
    try
    {
      var invoice = result.raw.getElementsByTagName("Invoice")[0];
      document.getElementById("contentInfo").innerHTML = "";
      CurrentId = invoice.getElementsByTagName("InvoiceId")[0].text;
      document.getElementById("contentInfo").innerHTML += "<b>Номер счета:</b> "+invoice.getElementsByTagName("InvoiceId")[0].text+"<br />";
      document.getElementById("contentInfo").innerHTML += "<b>Отправитель:</b> "+invoice.getElementsByTagName("FromUserTitle")[0].text+"<br />";
      document.getElementById("contentInfo").innerHTML += "<b>Сумма:</b> "+invoice.getElementsByTagName("Amount")[0].text+((invoice.getElementsByTagName("CurrencyId")[0].text == "643") ? "RUR" : "USD")+"<br />";
      document.getElementById("contentInfo").innerHTML += "<b>Описание счета:<b> "+((invoice.getElementsByTagName("Description").length>0) ? invoice.getElementsByTagName("Description")[0].text : "")+"<br />";
      document.getElementById("contentInfo").innerHTML += "<b>Дата создание:<b> "+invoice.getElementsByTagName("CreateDate")[0].text+"<br />";
      document.getElementById("accept").onclick = AcceptInvoice;
      document.getElementById("reject").onclick = RejectInvoice;
      document.getElementById("accept").value = "Принять";
      document.getElementById("accept").style.visibility = "visible";
      document.getElementById("reject").style.visibility = "visible";
      document.getElementById("accept").disabled = false;
      document.getElementById("reject").disabled = false;
    }
    catch(e)
    {
      document.getElementById("errorInfo").innerHTML = "Нет данных по новым счетам.";
    }
  }
}

function AcceptInvoice()
{
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+document.getElementById("session").value+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.InvoiceId = CurrentId;
  callObj.funcName = "AcceptInvoice";
  var iCallID = service.Processing.callService(_AcceptInvoice, callObj);
}

function _AcceptInvoice(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("errorInfo").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
    }
    else
    {
      document.getElementById("errorInfo").innerText = xfaultstring;
    }
  }
  else
  {
    document.getElementById("contentInfo").innerText = "Счет успешно принят";
    document.getElementById("accept").style.visibility = "visible";
    document.getElementById("accept").value = "Следующий...";
    document.getElementById("accept").onclick = Load;
    document.getElementById("reject").style.visibility = "hidden";
  }
}

function RejectInvoice()
{
  document.getElementById("errorInfo").innerHTML = "";
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+document.getElementById("session").value+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.InvoiceId = CurrentId;
  callObj.funcName = "RejectInvoice";
  var iCallID = service.Processing.callService(_RejectInvoice, callObj);
}

function _RejectInvoice(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("errorInfo").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
    }
    else
    {
      document.getElementById("errorInfo").innerText = xfaultstring;
    }
  }
  else
  {
    document.getElementById("contentInfo").innerText = "Счет успешно отвергнут";
    document.getElementById("accept").style.visibility = "visible";
    document.getElementById("accept").value = "Следующий...";
    document.getElementById("accept").onclick = Load;
    document.getElementById("reject").style.visibility = "hidden";
  }
}


//Переводы
function GetTransfersByPage()
{
  document.getElementById("errorInfo").innerHTML = "";
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+document.getElementById("session").value+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.PageNumber = 1;
  callObj.params.ItemsPerPage = 1;
  callObj.params.StateFilter = "Created";
  callObj.params.ToUserId = System.Gadget.Settings.readString("CurrentUserId");
  callObj.funcName = "GetTransfersByPage";
  var iCallID = service.Processing.callService(_GetTransfersByPage, callObj);
}

function _GetTransfersByPage(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("errorInfo").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
    }
    else
    {
      document.getElementById("errorInfo").innerText = xfaultstring;
    }
  }
  else
  {
    try
    {
      var Transfer = result.raw.getElementsByTagName("Transfer")[0];
      document.getElementById("contentInfo").innerHTML = "";
      CurrentId = Transfer.getElementsByTagName("TransferId")[0].text;
      document.getElementById("contentInfo").innerHTML += "<b>Номер перевода:</b> "+Transfer.getElementsByTagName("TransferId")[0].text+"<br />";
      document.getElementById("contentInfo").innerHTML += "<b>Отправитель:</b> "+Transfer.getElementsByTagName("FromUserTitle")[0].text+"<br />";
      document.getElementById("contentInfo").innerHTML += "<b>Сумма:</b> "+Transfer.getElementsByTagName("Amount")[0].text+"<br />";
      document.getElementById("contentInfo").innerHTML += "<b>Описание перевода:</b> "+((Transfer.getElementsByTagName("Description").length>0) ? Transfer.getElementsByTagName("Description")[0].text : "")+"<br />";
      document.getElementById("contentInfo").innerHTML += "<b>Дата создание:</b> "+Transfer.getElementsByTagName("CreateDate")[0].text+"<br />";
      if (Transfer.getElementsByTagName("IsProtected")[0].text.toString().toLowerCase() == "true")
      {
        document.getElementById("contentInfo").innerHTML += "<b>Код защиты</b> <input id='protect' type='text' style='width: 100px'/>";
      }
      document.getElementById("accept").onclick = AcceptTransfer;
      document.getElementById("reject").onclick = RejectTransfer;
      document.getElementById("accept").value = "Принять";
      document.getElementById("accept").style.visibility = "visible";
      document.getElementById("reject").style.visibility = "visible";
      document.getElementById("accept").disabled = false;
      document.getElementById("reject").disabled = false;
    }
    catch(e)
    {
      document.getElementById("contentInfo").innerHTML = "Нет данных по новым переводам.";
    }
  }
}

function AcceptTransfer()
{
  document.getElementById("errorInfo").innerHTML = "";
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+document.getElementById("session").value+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.TransferId = CurrentId;
  if (document.getElementById("protect") != undefined)
  {
    if (document.getElementById("protect").value != "")
    {
      callObj.params.UnlockCode = document.getElementById("protect").value;
    }
  }
  callObj.funcName = "AcceptTransfer";
  var iCallID = service.Processing.callService(_AcceptTransfer, callObj);
}

function _AcceptTransfer(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("errorInfo").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
    }
    else
    {
      document.getElementById("errorInfo").innerText = xfaultstring;
    }
  }
  else
  {
    document.getElementById("contentInfo").innerText = "Перевод успешно принят";
    document.getElementById("accept").style.visibility = "visible";
    document.getElementById("accept").value = "Следующий...";
    document.getElementById("accept").onclick = Load;
    document.getElementById("reject").style.visibility = "hidden";
  }
}

function RejectTransfer()
{
  document.getElementById("errorInfo").innerHTML = "";
  service.useService("ProcessingService.wsdl","Processing");
  var SoapHeader = "<SessionKey>"+document.getElementById("session").value+"</SessionKey>";
  var callObj;
  callObj = service.createCallOptions();
  callObj.async = true;
  callObj.SOAPHeader = new Array();
  callObj.SOAPHeader[0] = SoapHeader;
  callObj.params = new Array();
  callObj.params.TransferId = CurrentId;
  callObj.funcName = "RejectTransfer";
  var iCallID = service.Processing.callService(_RejectTransfer, callObj);
}

function _RejectTransfer(result)
{
  if(result.error)
  {
    var xfaultcode   = result.errorDetail.code;
    var xfaultstring = result.errorDetail.string;
    var xfaultsoap   = result.errorDetail.raw;
    if (xfaultsoap != null)
    {
      document.getElementById("errorInfo").innerHTML = xfaultsoap.getElementsByTagName("message")[0].text;
    }
    else
    {
      document.getElementById("errorInfo").innerText = xfaultstring;
    }
  }
  else
  {
    document.getElementById("contentInfo").innerText = "Перевод успешно отвергнут";
    document.getElementById("accept").style.visibility = "visible";
    document.getElementById("accept").value = "Следующий...";
    document.getElementById("accept").onclick = Load;
    document.getElementById("reject").style.visibility = "hidden";
  }
}

 